#ifndef LIBFAWK_STR_H
#define LIBFAWK_STR_H

#include <libfawk/libfawk.h>

/* Allocate a new string and copy s in it. If len_limit is -1, the whole
   string is copied, else at most len_limit bytes are copied. */
FAWK_API fawk_str_t *fawk_str_new_from_literal(fawk_ctx_t *ctx, const char *s, size_t len_limit);

/* Allocate a new string cloning an existing one, plus bump allocation size
   by enlarge bytes */
FAWK_API fawk_str_t *fawk_str_clone(fawk_ctx_t *ctx, fawk_str_t *src, size_t enlarge);

/* Duplicate src and return the new pointer (in some rare cases this is a new
   string) */
FAWK_API fawk_str_t *fawk_str_dup(fawk_ctx_t *ctx, fawk_str_t *src);

/* Release src: decrease the refco and free it if there are no more refs */
FAWK_API void fawk_str_free(fawk_ctx_t *ctx, fawk_str_t *src);

/* Allocate a new string with refco=1 in which s1 and s2 are concatenated. */
FAWK_API fawk_str_t *fawk_str_concat(fawk_ctx_t *ctx, fawk_str_t *s1, fawk_str_t *s2);

#endif /* LIBFAWK_STR_H */
